/* Copyright (c) 2016, The Linux Foundation. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above
 *       copyright notice, this list of conditions and the following
 *       disclaimer in the documentation and/or other materials provided
 *       with the distribution.
 *     * Neither the name of The Linux Foundation nor the names of its
 *       contributors may be used to endorse or promote products derived
 *       from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED "AS IS" AND ANY EXPRESS OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NON-INFRINGEMENT
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
 * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR
 * BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
 * OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN
 * IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 */


#ifndef __DRIVER_CMD_NL80211_EXTN__
#define __DRIVER_CMD_NL80211_EXTN__

#include "qca-vendor_copy.h"

#define IFNAMSIZ 16
#define WPA_DRIVER_OEM_STATUS_SUCCESS 0
#define WPA_DRIVER_OEM_STATUS_FAILURE 255

/*
 * This structure is a table of function pointers to the functions
 * used by the wpa_supplicant_lib to interface with oem specific APIs
 */
typedef struct
{
    int (*wpa_driver_driver_cmd_oem_cb)(void *priv,
			char *cmd, char *buf, size_t buf_len, int *status);
} wpa_driver_oem_cb_table_t;

typedef wpa_driver_oem_cb_table_t* (wpa_driver_oem_get_cb_table_t)();

int wpa_driver_oem_initialize(wpa_driver_oem_cb_table_t *oem_lib_params);
#endif
